#include "exo1.h"

/*@ requires x < INT_MAX;
  @ assigns \nothing;
  @ ensures \result == nextInt(x);
*/
int plusOne(int x){
	return x+1;
}

/* @ requires x>=1;
  @ assigns \nothing;
  @ ensures \result == sumOfInt(x);
 */
int sumInt(int x){
	int res = 0;
	/* Mettre les bons invariants (et variant) de boucle.
	 */
	for(int i = 1;i<=x;i++) {
		res+=i;
		//@ assert res == (i*(i-1)+2*i)/2;
	}
	return res;
}

/* @ requires n>0;
  @ requires \valid(t + (0 .. n-1));
  @ ensures \result == sumFirstLast(t,n);
 */
int sumFL(int *t, int n){
	return t[0] + t[n-1];
}

/* @ requires n>0;
  @ requires \valid(t + (0 .. n-1));
  @ ensures \result == sumFirstLast(t,n);
 */
int sumFLBis(int *t, int n){
	int res = t[0] + t[n-1];
	t[0] = 0;
	t[n-1] = 0;
	return res;
}

/*@ assigns \nothing;
  @ ensures \result == fibonacci(x);
 */
int fibo(int x){
	if(x<=0) return 0;
	if(x==1) return 1;
	int prev = 0;
	int res = 1;
	int i = 1;
	/*@ loop invariant 1<=i<=x;
	  @ loop invariant res == fibonacci(i);
	  @ loop invariant prev == fibonacci(i-1);
	  @ loop assigns i,res,prev;
	  @ loop variant x-i;
	 */
	while (i<x){
		int aux = res;
		res = res + prev;
		prev = aux;
		i++;
	}
	return res;
}

/* @ requires \valid(t + (0 .. n-1));
  @ assigns \nothing;
  @ ensures \result == sumOfTab(t,0,n);
 */
int sumOfTab(int *t, int n){
	if (n<=0) return 0;
	int res = 0;
	/* invariants de boucles (et variants).
	 */
	for(int i = 0; i<n; i++) res+=t[i];
	return res;
}


/* @ requires \valid(t+ (0 .. n-1));
  @ assigns \nothing;
  @ ensures \result == countTab(t,0,n,val);
 */
int countTab(int *t, int n, int val){
	if(n<=0) return 0;
	int res = 0;
	/* invariants et variants.
	 */
	for(int i = 0; i<n; i++){
		if(t[i] == val) res++;
	}
	return res;
}

/* @ requires \valid(t + (0 .. n-1));
  @ assigns t[0..n-1];
  @ ensures \forall integer j; 0<=j<n ==> t[j] == sumOfTab(t,0,j+1);
 */
void sumOfTabInTab(int *t, int n){
	if (n<=0) return;
	int res = 0;
	/* invariants et variant
	 */
	for(int i = 0; i<n; i++) {
		res+=t[i];
		t[i] = res;
	}
	return;
}