#include "exo2.h"

/*@ assigns \nothing;
  @ ensures isPositive(\result);
 */
int abs(int x){
	if(x<0) return -x;
	return x;
}

/* @ requires \valid(t + (i .. n-1));
  @ assigns t[i .. n-1];
  @ ensures isBiggerThanTab(x,t,i,n);
 */
void ceilTab(int x, int *t, int i, int n){
	if(n<i) return;
	/* à compléter
	 */
	for(int j = i; j<n;j++){
		if(t[j]>x) t[j] = x;
	}
	return;
}

/* @ requires \valid(t + (i .. n-1));
  @ requires \valid(s + (i .. n-1));
  @ requires \separated(t + (i .. n-1),s + (i .. n-1));
  @ assigns s[i .. n-1];
  @ ensures tabNextInt(t,s,i,n);
 */
void addOneInTab(int *t, int *s, int i, int n){
	if(n<i) return;
	/* à compléter
	 */
	for(int j = i; j<n; j++) {
		s[j] = t[j] +1;
	}
	return;
}

/* @ requires \valid(t + (i .. n-1));
  @ assigns t[i .. n-1];
  @ ensures tabNextInt(t,t,i,n);
 */
void addOneTab(int *t, int i, int n){
	if (n<i) return;
	/*à compléter
	 */
	for(int j = i; j<n; j++){
		t[j]++;
	}
	return;
}

/*@ requires \valid(t + (i .. n-1));
  @ assigns \nothing;
  @ ensures fiboTab(t,i,n) <==> \result == 1;
  @ ensures !fiboTab(t,i,n) <==> \result == 0;
 */
int isFiboTab(int *t, int i, int n){
	if(n<=i+2) return 1;
	/*@ loop assigns j;
	  @ loop invariant fiboTab(t,i,j);
	  @ loop invariant i+2<=j<=n;
	 */
	for(int j = i+2; j<n; j++){
		if(t[j] != t[j-1] + t[j-2]) return 0;
	}
	return 1;
}

/* @ requires \valid(t + (0 .. n-1));
  @ requires n>i;
  @ assigns t[a],t[b];
  @ ensures swapInArray{Pre,Post}(t,t,i,n,a,b);
 */
void swapArray(int *t, int i, int n, int a, int b){
	if (a<i || n<=a || b<i || n<=b) return;
	int aux = t[a];
	t[a] = t[b];
	t[b] = aux;
}

/* @ requires \valid(t + (0 .. n-1));
  @ requires n>i;
  @ requires i <= a < b <n;
  @ requires i <= c < d <n;
  @ requires i <= e < f <n;
  @ assigns t[a],t[b],t[c],t[d],t[e],t[f];
  @ ensures permutation{Pre,Post}(t,t,i,n);
 */
void threeSwap(int *t, int i, int n, int a, int b, int c, int d, int e, int f){
	// @ assert permutation{Pre,Here}(t,t,i,n);
	swapArray(t,i,n,a,b);
	swapArray(t,i,n,c,d);
	swapArray(t,i,n,e,f);
}
